{
PixaMSN
Copyright (C) 2005 Sergi Martinez (pixador@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
}

unit UNotification;

//{$DEFINE Debug}

interface

uses
  Windows, Wininet, SysUtils, Classes, Controls, Forms, graphics,
  ImgList, ComCtrls, StdCtrls, ScktComp, ExtCtrls, UUtils, USw, md5, Menus;

type
  ExtraCallBack = procedure (aText: string) of object;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    ImageList1: TImageList;
    ClientSocket1: TClientSocket;
    ClientSocket2: TClientSocket;
    Panel1: TPanel;
    Button2: TButton;
    StatusCombo: TComboBox;
    Label3: TLabel;
    UserPopup: TPopupMenu;
    miBlock: TMenuItem;
    miUnblock: TMenuItem;
    miDelete: TMenuItem;
    ExtraPanel: TPanel;
    ExtraEdit: TEdit;
    ExtraLabel: TLabel;
    miChat: TMenuItem;
    N2: TMenuItem;
    ManualPopUp: TPopupMenu;
    miAbout: TMenuItem;
    miAddUser: TMenuItem;
    miChangeName: TMenuItem;
    LoginPanel: TPanel;
    Label1: TLabel;
    UserEdit: TEdit;
    Label2: TLabel;
    PassEdit: TEdit;
    Button1: TButton;
    miFlash: TMenuItem;
    miPopUp: TMenuItem;
    N1: TMenuItem;
    N3: TMenuItem;
    miNewMail: TMenuItem;
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure Button2Click(Sender: TObject);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ListView1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StatusComboChange(Sender: TObject);
    procedure StatusComboDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListView1CustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure UserPopupPopup(Sender: TObject);
    procedure miDeleteClick(Sender: TObject);
    procedure miUnblockClick(Sender: TObject);
    procedure miBlockClick(Sender: TObject);
    procedure ClientSocket2Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure miAddUserClick(Sender: TObject);
    procedure ExtraEditKeyPress(Sender: TObject; var Key: Char);
    procedure miChangeNameClick(Sender: TObject);
    procedure miAboutClick(Sender: TObject);
    procedure miToggleCheckBox(Sender: TObject);
  private
    FBuff: ansistring;
    FSwB : TStringList;
    FTrId: cardinal;
    FMyAd: string;
    FMyNm: string;
    Fcon1: boolean;
    Fnumcontactes: integer;
    FExtraCB: ExtraCallBack;

    procedure envia(s1,s2:string;appendcrlf:boolean=true);
    procedure procesa(linia:string);
    procedure SbClose(aEmail: string);
    procedure SbNewSb(aEmail: string);
    procedure FlashWin(aHwnd: HWND);
    procedure AcceptarUsuari(aEmail, aName: string);
    procedure AddNewUserCB(aText: string);
    procedure ChangeNameCB(aText: string);
  public
    { Public declarations }
    procedure AddToList(aEmail, aName: string; aFlags: integer);
    procedure SetStatus(aEmail, aName, aStatus: string);
    procedure OnMyShowHint(var HintStr: string; var CanShow: Boolean; var HintInfo: THintInfo);
  end;

var
  Form1: TForm1;
  loginhost: string ='';

implementation

{$R *.DFM}

procedure ErrorMessage(aMessage: string);
begin
  Form1.envia('OUT','');
  MessageBox(0, pchar(aMessage), 'PixaMSN', MB_OK + MB_ICONERROR);
  form1.button1.enabled:=true;
  form1.useredit.enabled:=true;
  form1.passedit.enabled:=true;
  screen.cursor:=crDefault;
end;

function sslget(url,chal:string):string;
var
  NetHandle,UrlHandle: HINTERNET;
  Buffer: array[0..4095] of Char;
  auth,username,password:string;
  dummy,kk: dWord;
begin
  Application.ProcessMessages;
  password:=form1.passedit.text;
  username:=form1.useredit.text; // Get username and changes @ into %40
  username:=copy(username,1,pos('@',username)-1)+'%40'+copy(username,pos('@',username)+1,222);
  if chal<>'' then auth:='Authorization: Passport1.4 OrgVerb=GET,OrgURL=http%3A%2F%2Fmessenger%2Emsn%2Ecom,sign-in='+username+',pwd='+password+','+chal;
  NetHandle := InternetOpen('MSMSGS', INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, INTERNET_FLAG_NO_COOKIES + INTERNET_FLAG_NO_UI + INTERNET_FLAG_PRAGMA_NOCACHE + INTERNET_FLAG_SECURE);
  UrlHandle := InternetOpenUrl(NetHandle, PChar(url), pchar(auth), dword(-1), INTERNET_FLAG_NO_COOKIES + INTERNET_FLAG_NO_AUTO_REDIRECT + INTERNET_FLAG_NO_AUTH + INTERNET_FLAG_IGNORE_CERT_CN_INVALID + INTERNET_FLAG_IGNORE_CERT_DATE_INVALID, 0);
  FillChar(Buffer, SizeOf(Buffer), 0);
  kk:=SizeOf(Buffer);
  dummy:=0;
  HttpQueryInfo(UrlHandle,HTTP_QUERY_RAW_HEADERS_CRLF,@Buffer,kk,dummy);
  result:=buffer;
  InternetCloseHandle(UrlHandle);
  InternetCloseHandle(NetHandle);
  Application.ProcessMessages;
end;

function fesauth(chal:string):string;
begin
  if loginhost='' then begin // We must find the login server
    loginhost:=sslget('https://nexus.passport.com/rdr/pprdr.asp',''); // Tells us what the login server is
    delete(loginhost,1,pos('DALogin=',loginhost)+7); // Server is after DALogin=
    loginhost:='https://'+copy(loginhost,1,pos(',',loginhost)-1); // We add "https://" to the address
  end;
  result:=sslget(loginhost,chal); // Connect to login server
  while pos('Location: ',result)>0 do begin // Loop here if server redirects us
    result:=copy(result,pos('Location: ',result)+10,22222);
    result:=copy(result,1,pos(#13,result)-1);
    result:=sslget(result,chal); // result = address we're been redirected (begins with https://)
  end;
  if pos('da-status=success',result)>0 then begin // we succeeded
    delete(result,1,pos('from-PP=',result)+8); // Get the "blahblahblah" of "from-PP='blahblahblah'
    result:=copy(result,1,pos('''',result)-1); // result = our passport auth :)
  end
  else begin // we failed
    delete(result,1,pos('cbtxt=',result)+5); // get error message
    if pos(#13, result)>0 then result:=copy(result, 1, pos(#13,result)-1);
    ErrorMessage(utf2asc(urldecode(result)));
    result:='';
  end;
end;

// ------------------------------------------------------------------

procedure TForm1.envia(s1,s2:string;appendcrlf:boolean=true);
var s:string;
begin
  s:=s1+' '+inttostr(FTrId);
  if s2<>'' then s:=s+' '+s2;
  inc(FTrId);
  if (appendcrlf) then s:=s+#13#10;
  if Fcon1 then form1.clientsocket1.socket.sendtext(s)
  else form1.clientsocket2.socket.sendtext(s);
  {$IFDEF Debug}log('PixaMSNlog.txt', 'NSS: '+s);{$ENDIF}
end;

procedure TForm1.procesa(linia:string);
var
  tmp: string;
  s  : string;
  i  : integer;
  b  : boolean;
  f  : TSwForm;
  li : TListItem;
begin
  {$IFDEF Debug}log('PixaMSNlog.txt', 'NSR: '+linia);{$ENDIF}
  tmp:=copy(linia,1,3);

  if tmp='VER' then begin
    envia('CVR','0x0409 winnt 5.1 i386 MSNMSGR 5.0.0540 MSMSGS '+form1.useredit.text);
    exit;
  end;

  if tmp='CVR' then begin
    envia('USR','TWN I '+form1.useredit.text);
    exit;
  end;

  if tmp='XFR' then begin
    i:=pos(' NS ',linia);
    if i>0 then begin
      linia:=copy(linia,i+4,22222);
      if Fcon1 then begin
        form1.clientsocket2.host:='';
        form1.clientsocket2.address:=copy(linia,1,pos(':',linia)-1);
        linia:=copy(linia,pos(':',linia)+1,22222);
        i:=pos(#32,linia);
        if i>0 then linia:=copy(linia,1,i-1);
        form1.clientsocket2.port:=strtoint(linia);
        Fcon1:=false;
        form1.clientsocket2.active:=true;
        form1.clientsocket1.close;
      end
      else begin
        form1.clientsocket1.host:='';
        form1.clientsocket1.address:=copy(linia,1,pos(':',linia)-1);
        form1.clientsocket1.port:=strtoint(copy(linia,pos(':',linia)+1,22222));
        Fcon1:=true;
        form1.clientsocket1.active:=true;
        form1.clientsocket2.close;
      end;
    end
    else begin
      if param(linia, 3)='SB' then begin
        f:=nil;
        for i:=0 to FSwB.Count-1 do begin
          f:=FSwB.Objects[i] as TSwForm;
          if not(f.Started) then break;
        end;
        if ((f<>nil) and (not f.Started)) then f.Start(param(linia, 4), param(linia, 6), true);
      end;
    end;
    exit;
  end;

  if tmp='USR' then begin
    if pos(' OK ',linia)>0 then begin
      FMyNm:=utf2asc(urldecode(param(linia, 5)));
      envia('SYN','0');
    end
    else begin
      i:=pos('TWN S',linia)+6;
      envia('USR','TWN S '+fesauth(copy(linia,i,22222)));
    end;
    exit;
  end;

  if tmp='911' then ErrorMessage('Nom d''utilisateur ou mot de passe incorrect');

  if tmp='OUT' then begin
    ErrorMessage('Connexion termine par le serveur');
    Form1.ListView1.Items.Clear;
    exit;
  end;

  if tmp='SYN' then begin
    Fnumcontactes:=strtoint(param(linia, 4));
    if (Fnumcontactes=0) then envia('CHG','HDN');
    screen.Cursor:=crDefault;
    exit;
  end;

  if tmp='LST' then begin
    i:=strtoint(param(linia, 4));
    if (i and 1)>0 then begin // esta a la FL?
      Form1.AddToList(param(linia, 2), param(linia, 3), i);
      if ((i and (4+2))=0) then Envia('ADD', 'AL '+param(linia, 2)+' '+param(linia, 3));
    end
    else begin
      if (i and 8)>0 then begin // est a la RL?
        if (i and 2)>0 then Envia('REM', 'AL '+param(linia, 2));
        if (i and 4)=0 then AcceptarUsuari(param(linia, 2), param(linia, 3));
      end
      else begin // No est a FL ni a RL: fem neteja
        if (i and 2)>0 then Envia('REM', 'AL '+param(linia, 2));
        if (i and 4)>0 then Envia('REM', 'BL '+param(linia, 2));
      end
    end;
    dec(Fnumcontactes);
    if (Fnumcontactes=0) then envia('CHG','HDN');
    exit;
  end;

  if tmp='CHL' then begin
    delete(linia,1,pos(#32,linia));
    delete(linia,1,pos(#32,linia));
    envia('QRY','PROD0038W!61ZTF9 32'+#13#10+md5string(linia+'VT6PX?UQTM4WM%YR'),false);
    exit;
  end;

  if tmp='ILN' then begin
    Form1.SetStatus(param(linia, 4), param(linia, 5), param(linia, 3));
    exit;
  end;

  if tmp='FLN' then begin
    Form1.SetStatus(param(linia, 2), '', 'FLN');
    exit;
  end;

  if tmp='NLN' then begin
    Form1.SetStatus(param(linia, 3), param(linia, 4), param(linia, 2));
    exit;
  end;

  if tmp='RNG' then begin
    s:=param(linia, 6);
    i:=FSwB.IndexOf(s);
    if (i=-1) then begin
      f:=TSwForm.Create(self, FMyAd, s, SbClose, SbNewSb);
      f.FlashCB:=FlashWin;
      FSwB.AddObject(s, f);
    end
    else f:=FSwB.Objects[i] as TSwForm;
    f.Start(param(linia, 3), param(linia, 5)+' '+param(linia, 2), false);
    exit;
  end;

  if tmp='CHG' then begin
    StatusCombo.Color:=clWindow;
    StatusCombo.Enabled:=true;
    LoginPanel.Visible:=false;
    s:='0NLN 1BSY 2IDL 3BRB 4AWY 5PHN 6LUN 7HDN';
    i:=pos(param(linia, 3), s);
    StatusCombo.ItemIndex:=strtoint(s[i-1]);
    miAddUser.Enabled:=true;
    miChangeName.Enabled:=true;
    exit;
  end;

  if tmp='ADD' then begin
    if (param(linia, 3)='FL') then AddToList(param(linia, 5), param(linia, 6), 1+2);
    if (param(linia, 3)='RL') then begin
      s:=param(linia, 5);
      b:=false;
      for i:=0 to ListView1.Items.Count-1 do begin
        li:=ListView1.Items[i];
        if (s=li.SubItems[0]) then begin
          li.Data:=Pointer(Integer(li.Data) or 8);
          ListView1.AlphaSort;
          b:=true;
          break;
        end;
      end;
      if not(b) then AcceptarUsuari(s, param(linia, 6));
    end;
    exit;
  end;

  if tmp='REM' then begin
    if (param(linia, 3)='RL') then begin
      s:=param(linia, 5);
      for i:=0 to ListView1.Items.Count-1 do begin
        li:=ListView1.Items[i];
        if (s=li.SubItems[0]) then begin
          li.Data:=Pointer(Integer(li.Data) and (1+2+4));
          li.ImageIndex:=7;
          ListView1.AlphaSort;
          break;
        end;
      end;
    end;
    exit;
  end;

  if tmp='NOT' then begin
    delete(FBuff, 1, strtoint(param(linia, 2)));
    if Fcon1 then ClientSocket1Read(Self, ClientSocket1.Socket)
    else ClientSocket1Read(Self, ClientSocket2.Socket);
  end;

  if tmp='Inb' then begin // Inbox-Unread: 1
    if (param(linia, 1)<>'Inbox-Unread:') then exit;
    s:=param(linia, 2);
    if (s='0') then exit;
    s:='Vous avez '+s+' email(s) non-lu(s).';
    Application.MessageBox(pchar(s), 'PixaMSN', MB_OK + MB_ICONINFORMATION);
    exit;
  end;

  if tmp='Fro' then begin // From: Pixador Delterrat
    if ((not Form1.miNewMail.Checked) or (param(linia, 1)<>'From:')) then exit;
    s:='Vous avez reu un nouvel email de: '+copy(linia, 7, length(linia))+'.';
    Application.MessageBox(pchar(s), 'PixaMSN', MB_OK + MB_ICONINFORMATION);
    exit;
  end;

end;

procedure TForm1.AcceptarUsuari(aEmail, aName: string);
var
  s: string;
begin
  SetForegroundWindow(Handle);
  s:=aEmail+' ('+aName+') vous a ajout  sa liste de contacts.'+#10+'Voulez-vous l''ajouter  votre liste?';
  if (Application.MessageBox(pchar(s), 'PixaMSN', MB_YESNO + MB_ICONQUESTION) = IDYES) then begin
    Envia('ADD', 'FL '+aEmail+' '+aName);
    Envia('ADD', 'AL '+aEmail+' '+aName);
    AddToList(aEmail, aName, 1+2+8);
  end
  else Envia('ADD', 'BL '+aEmail+' '+aName);
end;

// ----------------------------------------------------------------------

{ TForm1 }

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  FBuff:='';
  {$IFDEF Debug}
  envia('VER','MSNP9 CVR0');
  {$ELSE}
  envia('VER','MSNP8 CVR0');
  {$ENDIF}
  //envia('VER','MSNP9 MSNP8 CVR0');
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var
  p:integer;
  linia:string;
begin
  FBuff:=FBuff+socket.receivetext;
  while pos(#10,FBuff)>0 do begin
    p:=pos(#10,FBuff);
    linia:=copy(FBuff,1,p-2);
    FBuff:=copy(FBuff,p+1,22222);
    procesa(linia);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: integer;
begin
  if (clientsocket1.active) or (clientsocket2.active) then envia('OUT','');
  for i:=0 to FSwB.Count-1 do (FSwB.Objects[i] as TSwForm).Free;
  FSwB.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FSwB:=TStringList.Create;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if (PassEdit.Text='') then begin
    PassEdit.SetFocus;
    exit;
  end;
  {$IFDEF Debug}DeleteFile('PixaMSNlog.txt');{$ENDIF}
  Application.OnShowHint:=OnMyShowHint;
  screen.Cursor:=crHourGlass;
  UserEdit.Enabled:=false;
  PassEdit.Enabled:=false;
  Button1.Enabled:=false;
  FMyAd:=UserEdit.Text;
  Fcon1:=true;
  FTrId:=1;
  clientsocket1.active:=true;
end;

procedure TForm1.ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
var
  i1, i2: integer;
begin
  i1:=Item1.ImageIndex;
  i2:=Item2.ImageIndex;
  Compare:=0;
  if (i1<6) and (i2>5) then Compare:=-1 else
  if (i1>5) and (i2<6) then Compare:=1 else
  if (i1<5) and (i2=5) then Compare:=-1 else
  if (i1=5) and (i2<5) then Compare:=1
  else begin
    if (uppercase(Item1.Caption)<uppercase(Item2.Caption)) then Compare:=-1
    else Compare:=1;
  end;
end;

procedure TForm1.SetStatus(aEmail, aName, aStatus: string);
var
  st: integer;
  i : integer;
  li: TListItem;
begin
  li:=nil;
  for i:=0 to ListView1.Items.Count-1 do begin
    li:=ListView1.Items[i];
    if (li.SubItems[0]=aEmail) then break;
    li:=nil;
  end;
  if (li=nil) then exit;

  if (aStatus='NLN') then begin
    st:=0;
    li.SubItems[1]:='Etat: En ligne';
  end else
  if (aStatus='BSY') then begin
    st:=1;
    li.SubItems[1]:='Etat: Occup';
  end else
  if (aStatus='IDL') then begin
    st:=1;
    li.SubItems[1]:='Etat: Ne pas dranger';
  end else
  if (aStatus='BRB') then begin
    st:=2;
    li.SubItems[1]:='Etat: De retour dans une minute';
  end else
  if (aStatus='AWY') then begin
    st:=2;
    li.SubItems[1]:='Etat: Absent';
  end else
  if (aStatus='PHN') then begin
    st:=3;
    li.SubItems[1]:='Etat: Au tlphone';
  end else
  if (aStatus='LUN') then begin
    st:=4;
    li.SubItems[1]:='Etat: Parti manger';
  end else
  if (aStatus='FLN') then begin
    st:=5;
    li.SubItems[1]:='Etat: Hors ligne';
  end
  else begin
    st:=6;
    li.SubItems[1]:='Etat: Inconnu';
  end;

  i:=Integer(li.Data);
  if ((i and 8)<>0) then li.ImageIndex:=st; // no canviar la icona si ens ha esborrat

  if (aName<>'') then li.Caption:=utf2asc(urldecode(aName));
  ListView1.AlphaSort;
end;

procedure TForm1.AddToList(aEmail, aName: string; aFlags: integer);
var
  li: TListItem;
  i : integer;
begin
  for i:=0 to ListView1.Items.Count-1 do begin
    li:=ListView1.Items[i];
    if (aEmail=li.SubItems[0]) then exit; // Si ja existeix, no l'afegim
  end;
  li:=ListView1.Items.Add;
  li.Data:=Pointer(aFlags);
  li.Caption:=utf2asc(urldecode(aName));
  li.SubItems.Add(aEmail);
  li.SubItems.Add('Etat: Hors ligne');
  if ((aFlags and 8)=0) then begin // Ens ha esborrat
    li.ImageIndex:=7;
    li.SubItems.Add('-- Vous n''tes pas dans cette liste de contacts --');
  end
  else begin
    li.ImageIndex:=5;
    if ((aFlags and 4)=0) then
      li.SubItems.Add('[Pas Bloqu]')
    else
      li.SubItems.Add('[Bloqu]');
  end;

  Form1.ListView1.AlphaSort;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ManualPopUp.Popup(Mouse.CursorPos.x, Mouse.CursorPos.y);
end;

procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ErrorCode:=0;
  ErrorMessage('Erreur de connexion');
end;

procedure TForm1.ClientSocket2Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ErrorMessage('Connexion perdue');
end;

procedure TForm1.OnMyShowHint(var HintStr: string; var CanShow: Boolean;
  var HintInfo: THintInfo);
var
  cur: TPoint;
  li : TListItem;
begin
  CanShow:=false;
  GetCursorPos(Cur);
  cur:=ListView1.ScreenToClient(cur);
  li:=ListView1.GetItemAt(Cur.X, Cur.Y);
  if (li=nil) then exit;
  HintStr:=li.SubItems[0]+#10+li.SubItems[1]+#10+li.SubItems[2];
  CanShow:=true;
  HintInfo.ReshowTimeout:=1000;
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
var
  f  : TSwForm;
  i  : integer;
  nom: string;
  li : TListItem;
begin
  li:=ListView1.Selected;
  if (li=nil) then exit;
  nom:=li.SubItems[0];
  i:=FSwB.IndexOf(nom);
  if (i>=0) then begin
    f:=FSwB.Objects[i] as TSwForm;
    SetForegroundWindow(f.Handle);
    if ((f.WasConnected) and not(f.Ready)) then f.Started:=false;
  end
  else begin
    if (StatusCombo.ItemIndex<7) then begin
      f:=TSwForm.Create(self, FMyAd, nom, SbClose, SbNewSb);
      f.FlashCB:=FlashWin;
      FSwB.AddObject(nom, f);
    end
    else begin
      Application.MessageBox('Vous ne pouvez pas dmarrer une discussion tant que vous tes Invisible.', 'PixaMSN', MB_OK + MB_ICONWARNING);
      exit;
    end;
  end;
  if not(f.Started) then Envia('XFR', 'SB')
end;

procedure TForm1.SbClose(aEmail: string);
var
  i: integer;
begin
  i:=FSwB.IndexOf(aEmail);
  if (i>-1) then begin
    (FSwB.Objects[i] as TSwForm).Free;
    FSwB.Delete(i);
  end;
end;

procedure TForm1.SbNewSb(aEmail: string);
begin
  Envia('XFR', 'SB');
end;

procedure TForm1.StatusComboChange(Sender: TObject);
begin
  case StatusCombo.ItemIndex of
    0: Envia('CHG', 'NLN');
    1: Envia('CHG', 'BSY');
    2: Envia('CHG', 'IDL');
    3: Envia('CHG', 'BRB');
    4: Envia('CHG', 'AWY');
    5: Envia('CHG', 'PHN');
    6: Envia('CHG', 'LUN');
    7: Envia('CHG', 'HDN');
  end;
end;

procedure TForm1.StatusComboDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  bTemp:TBitmap;
begin
  bTemp:=TBitmap.Create;
  case Index of
    0: ImageList1.GetBitmap(0, bTemp);
    1: ImageList1.GetBitmap(1, bTemp);
    2: ImageList1.GetBitmap(1, bTemp);
    3: ImageList1.GetBitmap(2, bTemp);
    4: ImageList1.GetBitmap(2, bTemp);
    5: ImageList1.GetBitmap(3, bTemp);
    6: ImageList1.GetBitmap(4, bTemp);
    7: ImageList1.GetBitmap(6, bTemp);
  end;

  with (Control as TComboBox) do begin
   Canvas.FillRect(Rect);
   Canvas.TextOut(Rect.Left+ImageList1.Width+4,Rect.Top+1,Items[Index]);
   Canvas.Draw(Rect.Left,Rect.Top,bTemp);
  end;
  bTemp.Free;
end;

procedure TForm1.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if (Integer(Item.Data) and 4)<>0 then Sender.Canvas.Font.Color:=clRed;
end;

procedure TForm1.UserPopupPopup(Sender: TObject);
var
  li: TListItem;
begin
  miBlock.Enabled:=false;
  miUnBlock.Enabled:=false;
  miDelete.Enabled:=false;
  miChat.Enabled:=false;
  li:=ListView1.Selected;
  if (li=nil) then exit;
  miDelete.Enabled:=true;
  miChat.Enabled:=true;
  if (Integer(li.Data) and 4)=0 then begin
    miBlock.Enabled:=true;
    miBlock.Visible:=true;
    miUnblock.Visible:=false;
  end
  else begin
    miUnBlock.Enabled:=true;
    miUnBlock.Visible:=true;
    miBlock.Visible:=false;
  end;
end;

procedure TForm1.miDeleteClick(Sender: TObject);
var
  li: TListItem;
  i : integer;
  e : string;
  n : string;
begin
  li:=ListView1.Selected;
  if (li=nil) then exit;
  i:=Integer(li.Data);
  e:=li.SubItems[0];
  if (messagebox(0, pchar('Voulez-vous vraiment supprimer '+e+#10+'de votre liste de contacts?'),
                 'PixaMSN', MB_YESNO+MB_ICONQUESTION)=ID_NO) then exit;
  n:=urlencode(asc2utf(li.Caption));
  envia('REM', 'FL '+e);
  if ((i and 2)>0) then envia('REM', 'AL '+e);
  if ((i and 4)=0) and ((i and 8)>0) then envia('ADD', 'BL '+e+' '+n);
  ListView1.Items.Delete(li.Index);
end;

procedure TForm1.miUnblockClick(Sender: TObject);
var
  li: TListItem;
  i : integer;
  e : string;
  n : string;
begin
  li:=ListView1.Selected;
  if (li=nil) then exit;
  i:=Integer(li.Data);
  e:=li.SubItems[0];
  n:=urlencode(asc2utf(li.Caption));
  Envia('REM', 'BL '+e);
  Envia('ADD', 'AL '+e+' '+n);
  i:=i and (8+2+1);
  i:=i or 2;
  li.Data:=Pointer(i);
  li.SubItems[2]:='[Non Bloqu]';
end;

procedure TForm1.miBlockClick(Sender: TObject);
var
  li: TListItem;
  i : integer;
  e : string;
  n : string;
begin
  li:=ListView1.Selected;
  if (li=nil) then exit;
  i:=Integer(li.Data);
  e:=li.SubItems[0];
  n:=urlencode(asc2utf(li.Caption));
  Envia('REM', 'AL '+e);
  Envia('ADD', 'BL '+e+' '+n);
  i:=i and (8+4+1);
  i:=i or 4;
  li.Data:=Pointer(i);
  li.SubItems[2]:='[Bloqu]';
end;

procedure TForm1.miAboutClick(Sender: TObject);
begin
  MessageBox(0, #10+
                #9+#9+'        PixaMSN Fr'+#10+
                #9+#9+'        -------------'+#10+#10+
                #9+'Traduit par Sparad0x || www.trad-fr.com'+#10+#10+
                #9+'      Copyright  2007 Sergi Martinez'+#10+#10+
                'Distribu sous les termes de la GNU Lesser General Public Licence      '+#10+#10+
                '(Icnes: Miranda IM)'+#10+
                '(MD5  : Matthias Fichtner)'+#10+#10+
                'Email:             pixador@gmail.com'+#10+
                'Site Web:       http://www.pixador.com'+#10+#10,
                'A Propos de PixaMSN Fr', MB_OK + MB_ICONINFORMATION);
  ListView1.SetFocus;
end;

procedure TForm1.miChangeNameClick(Sender: TObject);
begin
  FExtraCB:=ChangeNameCB;
  ExtraLabel.Caption:='Votre pseudo:';
  ExtraEdit.Text:=FMyNm;
  ExtraPanel.Visible:=true;
  ExtraEdit.SetFocus;
end;

procedure TForm1.miAddUserClick(Sender: TObject);
begin
  FExtraCB:=AddNewUserCB;
  ExtraLabel.Caption:='Contact  ajouter:';
  ExtraEdit.Text:='@hotmail.com';
  ExtraPanel.Visible:=true;
  ExtraEdit.SetFocus;
end;

procedure TForm1.ExtraEditKeyPress(Sender: TObject; var Key: Char);
begin
  if (key=#27) then begin
    ExtraEdit.Clear;
    ExtraPanel.Visible:=false;
    key:=#0;
  end else
  if (key=#13) then begin
    ExtraPanel.Visible:=false;
    FExtraCB(ExtraEdit.Text);
    key:=#0;
  end;
end;

procedure TForm1.AddNewUserCB(aText: string);
begin
  if (aText='') then exit;
  Envia('ADD', 'FL '+aText+' '+aText);
  Envia('ADD', 'AL '+aText+' '+aText);
end;

procedure TForm1.ChangeNameCB(aText: string);
begin
  if (aText='') then exit;
  FMyNm:=aText;
  Envia('REA', FMyAd+' '+urlencode(asc2utf(aText)));
end;

procedure TForm1.FlashWin(aHwnd: HWND);
begin
  if (miPopUp.Checked) then SetForegroundWindow(aHwnd);
  if (miFlash.Checked) then begin
    if ((GetForegroundWindow<>Form1.Handle) and
        (GetForeGroundWindow<>aHwnd)) then FlashWindow(application.Handle,True);
  end;
end;

procedure TForm1.miToggleCheckBox(Sender: TObject);
var
  mi: TMenuItem;
begin
  mi:=Sender as TMenuItem;
  mi.Checked:=not(mi.Checked);
end;

end.

